## crowdsec 1.4.6

=== Makefile ===

ifeq ($(OS), Windows_NT)
	SHELL := pwsh.exe
	.SHELLFLAGS := -NoProfile -Command
	CS_ROOT = $(shell (Get-Location).Path)
	SYSTEM = windows
	EXT = .exe
else
	CS_ROOT ?= $(shell pwd)
	SYSTEM ?= $(shell uname -s | tr '[A-Z]' '[a-z]')
endif

ifneq ("$(wildcard $(CURDIR)/platform/$(SYSTEM).mk)", "")
	include $(CURDIR)/platform/$(SYSTEM).mk
else
	include $(CURDIR)/platform/linux.mk
endif

ifneq ($(OS), Windows_NT)
	include $(CS_ROOT)/platform/unix_common.mk
endif

CROWDSEC_FOLDER = ./cmd/crowdsec
CSCLI_FOLDER = ./cmd/crowdsec-cli/

HTTP_PLUGIN_FOLDER = ./plugins/notifications/http
SLACK_PLUGIN_FOLDER = ./plugins/notifications/slack
SPLUNK_PLUGIN_FOLDER = ./plugins/notifications/splunk
EMAIL_PLUGIN_FOLDER = ./plugins/notifications/email
DUMMY_PLUGIN_FOLDER = ./plugins/notifications/dummy

HTTP_PLUGIN_BIN = notification-http$(EXT)
SLACK_PLUGIN_BIN = notification-slack$(EXT)
SPLUNK_PLUGIN_BIN = notification-splunk$(EXT)
EMAIL_PLUGIN_BIN = notification-email$(EXT)
DUMMY_PLUGIN_BIN= notification-dummy$(EXT)

HTTP_PLUGIN_CONFIG = http.yaml
SLACK_PLUGIN_CONFIG = slack.yaml
SPLUNK_PLUGIN_CONFIG = splunk.yaml
EMAIL_PLUGIN_CONFIG = email.yaml

CROWDSEC_BIN = crowdsec$(EXT)
CSCLI_BIN = cscli$(EXT)
BUILD_CMD = build

MINIMUM_SUPPORTED_GO_MAJOR_VERSION = 1
MINIMUM_SUPPORTED_GO_MINOR_VERSION = 18
GO_VERSION_VALIDATION_ERR_MSG = Golang version ($(BUILD_GOVERSION)) is not supported, please use at least $(MINIMUM_SUPPORTED_GO_MAJOR_VERSION).$(MINIMUM_SUPPORTED_GO_MINOR_VERSION)

LD_OPTS_VARS= \
-X 'github.com/crowdsecurity/crowdsec/cmd/crowdsec.bincoverTesting=$(BINCOVER_TESTING)' \
-X 'github.com/crowdsecurity/crowdsec/cmd/crowdsec-cli.bincoverTesting=$(BINCOVER_TESTING)' \
-X 'github.com/crowdsecurity/crowdsec/pkg/cwversion.Version=$(BUILD_VERSION)' \
-X 'github.com/crowdsecurity/crowdsec/pkg/cwversion.BuildDate=$(BUILD_TIMESTAMP)' \
-X 'github.com/crowdsecurity/crowdsec/pkg/cwversion.Codename=$(BUILD_CODENAME)' \
-X 'github.com/crowdsecurity/crowdsec/pkg/cwversion.Tag=$(BUILD_TAG)' \
-X 'github.com/crowdsecurity/crowdsec/pkg/cwversion.GoVersion=$(BUILD_GOVERSION)' \
-X 'github.com/crowdsecurity/crowdsec/pkg/csconfig.defaultConfigDir=$(DEFAULT_CONFIGDIR)' \
-X 'github.com/crowdsecurity/crowdsec/pkg/csconfig.defaultDataDir=$(DEFAULT_DATADIR)'

ifdef BUILD_STATIC
	export LD_OPTS=-ldflags "-s -w $(LD_OPTS_VARS) -extldflags '-static'" -tags netgo,osusergo,sqlite_omit_load_extension
else
	export LD_OPTS=-ldflags "-s -w $(LD_OPTS_VARS)"
endif

GOCMD = go
GOTEST = $(GOCMD) test

RELDIR = crowdsec-$(BUILD_VERSION)

.PHONY: build
build: goversion crowdsec cscli plugins

.PHONY: all
all: clean test build

.PHONY: plugins
plugins: http-plugin slack-plugin splunk-plugin email-plugin dummy-plugin

.PHONY: goversion
goversion:
ifneq ($(OS), Windows_NT)
	@if [ $(GO_MAJOR_VERSION) -gt $(MINIMUM_SUPPORTED_GO_MAJOR_VERSION) ]; then \
		exit 0 ;\
	elif [ $(GO_MAJOR_VERSION) -lt $(MINIMUM_SUPPORTED_GO_MAJOR_VERSION) ]; then \
		echo '$(GO_VERSION_VALIDATION_ERR_MSG)';\
		exit 1; \
	elif [ $(GO_MINOR_VERSION) -lt $(MINIMUM_SUPPORTED_GO_MINOR_VERSION) ] ; then \
		echo '$(GO_VERSION_VALIDATION_ERR_MSG)';\
		exit 1; \
	fi
else
	# This needs Set-ExecutionPolicy -Scope CurrentUser Unrestricted
	@$(CS_ROOT)/scripts/check_go_version.ps1 $(MINIMUM_SUPPORTED_GO_MAJOR_VERSION) $(MINIMUM_SUPPORTED_GO_MINOR_VERSION)
endif

.PHONY: clean
clean: testclean
	@$(MAKE) -C $(CROWDSEC_FOLDER) clean --no-print-directory RM="$(RM)" WIN_IGNORE_ERR="$(WIN_IGNORE_ERR)" CP="$(CP)" CPR="$(CPR)" MKDIR="$(MKDIR)"
	@$(MAKE) -C $(CSCLI_FOLDER) clean --no-print-directory RM="$(RM)" WIN_IGNORE_ERR="$(WIN_IGNORE_ERR)" CP="$(CP)" CPR="$(CPR)" MKDIR="$(MKDIR)"
	@$(RM) $(CROWDSEC_BIN) $(WIN_IGNORE_ERR)
	@$(RM) $(CSCLI_BIN) $(WIN_IGNORE_ERR)
	@$(RM) *.log $(WIN_IGNORE_ERR)
	@$(RM) crowdsec-release.tgz $(WIN_IGNORE_ERR)
	@$(RM) crowdsec-release-static.tgz $(WIN_IGNORE_ERR)
	@$(RM) $(HTTP_PLUGIN_FOLDER)/$(HTTP_PLUGIN_BIN) $(WIN_IGNORE_ERR)
	@$(RM) $(SLACK_PLUGIN_FOLDER)/$(SLACK_PLUGIN_BIN) $(WIN_IGNORE_ERR)
	@$(RM) $(SPLUNK_PLUGIN_FOLDER)/$(SPLUNK_PLUGIN_BIN) $(WIN_IGNORE_ERR)
	@$(RM) $(EMAIL_PLUGIN_FOLDER)/$(EMAIL_PLUGIN_BIN) $(WIN_IGNORE_ERR)
	@$(RM) $(DUMMY_PLUGIN_FOLDER)/$(DUMMY_PLUGIN_BIN) $(WIN_IGNORE_ERR)


cscli: goversion
	@$(MAKE) -C $(CSCLI_FOLDER) build --no-print-directory GOARCH=$(GOARCH) GOOS=$(GOOS) RM="$(RM)" WIN_IGNORE_ERR="$(WIN_IGNORE_ERR)" CP="$(CP)" CPR="$(CPR)" MKDIR="$(MKDIR)"

cscli-bincover: goversion
	@GOARCH=$(GOARCH) GOOS=$(GOOS) $(MAKE) -C $(CSCLI_FOLDER) build-bincover --no-print-directory

crowdsec: goversion
	@$(MAKE) -C $(CROWDSEC_FOLDER) build --no-print-directory GOARCH=$(GOARCH) GOOS=$(GOOS) RM="$(RM)" WIN_IGNORE_ERR="$(WIN_IGNORE_ERR)" CP="$(CP)" CPR="$(CPR)" MKDIR="$(MKDIR)"

crowdsec-bincover: goversion
	@GOARCH=$(GOARCH) GOOS=$(GOOS) $(MAKE) -C $(CROWDSEC_FOLDER) build-bincover --no-print-directory

http-plugin: goversion
	@$(MAKE) -C $(HTTP_PLUGIN_FOLDER) build --no-print-directory GOARCH=$(GOARCH) GOOS=$(GOOS) RM="$(RM)" WIN_IGNORE_ERR="$(WIN_IGNORE_ERR)" CP="$(CP)" CPR="$(CPR)" MKDIR="$(MKDIR)"

slack-plugin: goversion
	@$(MAKE) -C $(SLACK_PLUGIN_FOLDER) build --no-print-directory GOARCH=$(GOARCH) GOOS=$(GOOS) RM="$(RM)" WIN_IGNORE_ERR="$(WIN_IGNORE_ERR)" CP="$(CP)" CPR="$(CPR)" MKDIR="$(MKDIR)"

splunk-plugin: goversion
	@$(MAKE) -C $(SPLUNK_PLUGIN_FOLDER) build --no-print-directory GOARCH=$(GOARCH) GOOS=$(GOOS) RM="$(RM)" WIN_IGNORE_ERR="$(WIN_IGNORE_ERR)" WIN_IGNORE_ERR="$(WIN_IGNORE_ERR)" CP="$(CP)" CPR="$(CPR)" MKDIR="$(MKDIR)"

email-plugin: goversion
	@$(MAKE) -C $(EMAIL_PLUGIN_FOLDER) build --no-print-directory GOARCH=$(GOARCH) GOOS=$(GOOS) RM="$(RM)" WIN_IGNORE_ERR="$(WIN_IGNORE_ERR)" CP="$(CP)" CPR="$(CPR)" MKDIR="$(MKDIR)"

dummy-plugin: goversion
	$(MAKE) -C $(DUMMY_PLUGIN_FOLDER) build --no-print-directory GOARCH=$(GOARCH) GOOS=$(GOOS) RM="$(RM)" WIN_IGNORE_ERR="$(WIN_IGNORE_ERR)" CP="$(CP)" CPR="$(CPR)" MKDIR="$(MKDIR)"

.PHONY: testclean
testclean: bats-clean
	@$(RM) pkg/apiserver/ent $(WIN_IGNORE_ERR)
	@$(RM) pkg/cwhub/hubdir $(WIN_IGNORE_ERR)
	@$(RM) pkg/cwhub/install $(WIN_IGNORE_ERR)
	@$(RM) pkg/types/example.txt $(WIN_IGNORE_ERR)

.PHONY: test
test: export AWS_ENDPOINT_FORCE=http://localhost:4566
test: goversion
	@echo 'NOTE: You need Docker, docker-compose and run "make localstack" in a separate shell ("make localstack-stop" to terminate it)'
	$(GOTEST) $(LD_OPTS) ./...

.PHONY: localstack
localstack:
	docker-compose -f tests/localstack/docker-compose.yml up

.PHONY: localstack-stop
localstack-stop:
	docker-compose -f tests/localstack/docker-compose.yml down

package-common:
	@echo "Building Release to dir $(RELDIR)"
	@$(MKDIR) $(RELDIR)/cmd/crowdsec
	@$(MKDIR) $(RELDIR)/cmd/crowdsec-cli
	@$(MKDIR) $(RELDIR)/$(subst ./,,$(HTTP_PLUGIN_FOLDER))
	@$(MKDIR) $(RELDIR)/$(subst ./,,$(SLACK_PLUGIN_FOLDER))
	@$(MKDIR) $(RELDIR)/$(subst ./,,$(SPLUNK_PLUGIN_FOLDER))
	@$(MKDIR) $(RELDIR)/$(subst ./,,$(EMAIL_PLUGIN_FOLDER))

	@$(CP) $(CROWDSEC_FOLDER)/$(CROWDSEC_BIN) $(RELDIR)/cmd/crowdsec
	@$(CP) $(CSCLI_FOLDER)/$(CSCLI_BIN) $(RELDIR)/cmd/crowdsec-cli

	@$(CP) $(HTTP_PLUGIN_FOLDER)/$(HTTP_PLUGIN_BIN) $(RELDIR)/$(subst ./,,$(HTTP_PLUGIN_FOLDER))
	@$(CP) $(SLACK_PLUGIN_FOLDER)/$(SLACK_PLUGIN_BIN) $(RELDIR)/$(subst ./,,$(SLACK_PLUGIN_FOLDER))
	@$(CP) $(SPLUNK_PLUGIN_FOLDER)/$(SPLUNK_PLUGIN_BIN) $(RELDIR)/$(subst ./,,$(SPLUNK_PLUGIN_FOLDER))
	@$(CP) $(EMAIL_PLUGIN_FOLDER)/$(EMAIL_PLUGIN_BIN) $(RELDIR)/$(subst ./,,$(EMAIL_PLUGIN_FOLDER))

	@$(CP) $(HTTP_PLUGIN_FOLDER)/$(HTTP_PLUGIN_CONFIG) $(RELDIR)/$(subst ./,,$(HTTP_PLUGIN_FOLDER))
	@$(CP) $(SLACK_PLUGIN_FOLDER)/$(SLACK_PLUGIN_CONFIG) $(RELDIR)/$(subst ./,,$(SLACK_PLUGIN_FOLDER))
	@$(CP) $(SPLUNK_PLUGIN_FOLDER)/$(SPLUNK_PLUGIN_CONFIG) $(RELDIR)/$(subst ./,,$(SPLUNK_PLUGIN_FOLDER))
	@$(CP) $(EMAIL_PLUGIN_FOLDER)/$(EMAIL_PLUGIN_CONFIG) $(RELDIR)/$(subst ./,,$(EMAIL_PLUGIN_FOLDER))

	@$(CPR) ./config $(RELDIR)
	@$(CP) wizard.sh $(RELDIR)
	@$(CP) scripts/test_env.sh $(RELDIR)
	@$(CP) scripts/test_env.ps1 $(RELDIR)

.PHONY: package
package: package-common
	@tar cvzf crowdsec-release.tgz $(RELDIR)

.PHONY: check_release
check_release:
ifneq ($(OS), Windows_NT)
	@if [ -d $(RELDIR) ]; then echo "$(RELDIR) already exists, abort" ;  exit 1 ; fi
else
	@if (Test-Path -Path $(RELDIR)) { echo "$(RELDIR) already exists, abort" ;  exit 1 ; }
endif

.PHONY: release
release: check_release build package

.PHONY: windows_installer
windows_installer: build
	@.\make_installer.ps1 -version $(BUILD_VERSION)

.PHONY: chocolatey
chocolatey: windows_installer
	@.\make_chocolatey.ps1 -version $(BUILD_VERSION)

include tests/bats.mk

=== cmd/crowdsec-cli/Makefile ===
ifeq ($(OS), Windows_NT)
	SHELL := pwsh.exe
	.SHELLFLAGS := -NoProfile -Command
	EXT = .exe
endif

# Go parameters
GOCMD = go
GOBUILD = $(GOCMD) build
GOCLEAN = $(GOCMD) clean
GOTEST = $(GOCMD) test
GOGET = $(GOCMD) get

BINARY_NAME = cscli$(EXT)
# names longer than 15 chars break 'pgrep'
BINARY_NAME_COVER = $(BINARY_NAME).cover
PREFIX ?= "/"
BIN_PREFIX = $(PREFIX)"/usr/local/bin/"

.PHONY: all
all: clean build

build: clean
	$(GOBUILD) $(LD_OPTS) $(BUILD_VENDOR_FLAGS) -o $(BINARY_NAME)

build-bincover: clean
	$(GOTEST) . -tags testrunmain -coverpkg=$(go list github.com/crowdsecurity/crowdsec/... | grep -v -e 'pkg/database' -e 'plugins/notifications' -e 'pkg/protobufs' -e 'pkg/cwversions' -e 'pkg/cstest' -e 'pkg/models') -covermode=atomic $(LD_OPTS) -c -o $(BINARY_NAME_COVER)

.PHONY: install
install: install-conf install-bin

install-conf:

install-bin:
	@install -v -m 755 -D "$(BINARY_NAME)" "$(BIN_PREFIX)/$(BINARY_NAME)" || exit

uninstall:
	@$(RM) $(CSCLI_CONFIG) $(WIN_IGNORE_ERR)
	@$(RM) $(BIN_PREFIX)$(BINARY_NAME) $(WIN_IGNORE_ERR)

clean:
	@$(RM) $(BINARY_NAME) $(BINARY_NAME_COVER) $(WIN_IGNORE_ERR)

=== cmd/crowdsec/Makefile ===
ifeq ($(OS), Windows_NT)
	SHELL := pwsh.exe
	.SHELLFLAGS := -NoProfile -Command
	EXT = .exe
endif

# Go parameters
GOCMD = go
GOBUILD = $(GOCMD) build
GOCLEAN = $(GOCMD) clean
GOTEST = $(GOCMD) test
GOGET = $(GOCMD) get

CROWDSEC_BIN = crowdsec$(EXT)
# names longer than 15 chars break 'pgrep'
CROWDSEC_BIN_COVER = $(CROWDSEC_BIN).cover
PREFIX ?= "/"
CFG_PREFIX = $(PREFIX)"/etc/crowdsec/config/"
BIN_PREFIX = $(PREFIX)"/usr/local/bin/"
DATA_PREFIX = $(PREFIX)"/var/run/crowdsec/"
PID_DIR = $(PREFIX)"/var/run/"

SYSTEMD_PATH_FILE = "/etc/systemd/system/crowdsec.service"

.PHONY: all
all: clean test build

build: clean
	$(GOBUILD) $(LD_OPTS) $(BUILD_VENDOR_FLAGS) -o $(CROWDSEC_BIN)

build-bincover: clean
	$(GOTEST) . -tags testrunmain -coverpkg=$(go list github.com/crowdsecurity/crowdsec/... | grep -v -e 'pkg/database' -e 'plugins/notifications' -e 'pkg/protobufs' -e 'pkg/cwversions' -e 'pkg/cstest' -e 'pkg/models') -covermode=atomic $(LD_OPTS) -c -o $(CROWDSEC_BIN_COVER)

test:
	$(GOTEST) $(LD_OPTS) -v ./...

clean:
	@$(RM) $(CROWDSEC_BIN) $(CROWDSEC_BIN).test $(CROWDSEC_BIN_COVER) $(WIN_IGNORE_ERR)

.PHONY: install
install: install-conf install-bin

.PHONY: install-conf
install-conf:
	mkdir -p $(DATA_PREFIX) || exit
	(cd ../.. / && find ./data -type f -exec install -Dm 755 "{}" "$(DATA_PREFIX){}" \; && cd ./cmd/crowdsec) || exit
	(cd ../../config && find ./patterns -type f -exec install -Dm 755 "{}" "$(CFG_PREFIX){}" \; && cd ../cmd/crowdsec) || exit
	mkdir -p "$(CFG_PREFIX)" || exit
	mkdir -p "$(CFG_PREFIX)/parsers" || exit
	mkdir -p "$(CFG_PREFIX)/scenarios" || exit
	mkdir -p "$(CFG_PREFIX)/postoverflows" || exit
	mkdir -p "$(CFG_PREFIX)/collections" || exit
	mkdir -p "$(CFG_PREFIX)/patterns" || exit
	install -v -m 755 -D ../../config/prod.yaml "$(CFG_PREFIX)" || exit
	install -v -m 755 -D ../../config/dev.yaml "$(CFG_PREFIX)" || exit
	install -v -m 755 -D ../../config/acquis.yaml "$(CFG_PREFIX)" || exit
	install -v -m 755 -D ../../config/profiles.yaml "$(CFG_PREFIX)" || exit
	install -v -m 755 -D ../../config/api.yaml "$(CFG_PREFIX)" || exit
	mkdir -p $(PID_DIR) || exit
	PID=$(PID_DIR) DATA=$(DATA_PREFIX)"/data/" CFG=$(CFG_PREFIX) envsubst < ../../config/prod.yaml > $(CFG_PREFIX)"/default.yaml"	

.PHONY: install-bin
install-bin:
	install -v -m 755 -D "$(CROWDSEC_BIN)" "$(BIN_PREFIX)/$(CROWDSEC_BIN)" || exit

.PHONY: systemd"$(BIN_PREFI"$(BIN_PREFIX)/$(CROWDSEC_BIN)""$(BIN_PREFIX)/$(CROWDSEC_BIN)"X)/$(CROWDSEC_BIN)"
systemd: install
	CFG=$(CFG_PREFIX) PID=$(PID_DIR) BIN=$(BIN_PREFIX)"/"$(CROWDSEC_BIN) envsubst < ../../config/crowdsec.service > "$(SYSTEMD_PATH_FILE)"
	systemctl daemon-reload

.PHONY: uninstall
uninstall:
	$(RM) $(CFG_PREFIX) $(WIN_IGNORE_ERR)
	$(RM) $(DATA_PREFIX) $(WIN_IGNORE_ERR) 
	$(RM) "$(BIN_PREFIX)/$(CROWDSEC_BIN)" $(WIN_IGNORE_ERR)
	$(RM) "$(SYSTEMD_PATH_FILE)" $(WIN_IGNORE_ERR)

=== plugins/notifications/dummy/Makefile ===
ifeq ($(OS), Windows_NT)
	SHELL := pwsh.exe
	.SHELLFLAGS := -NoProfile -Command
	EXT = .exe
endif

# Go parameters
GOCMD = go
GOBUILD = $(GOCMD) build
GOCLEAN = $(GOCMD) clean
GOTEST = $(GOCMD) test
GOGET = $(GOCMD) get

BINARY_NAME = notification-dummy$(EXT)

build: clean
	$(GOBUILD) $(LD_OPTS) $(BUILD_VENDOR_FLAGS) -o $(BINARY_NAME)

clean:
	@$(RM) $(BINARY_NAME) $(WIN_IGNORE_ERR)

=== plugins/notifications/email/Makefile ===
ifeq ($(OS), Windows_NT)
	SHELL := pwsh.exe
	.SHELLFLAGS := -NoProfile -Command
	EXT = .exe
endif

# Go parameters
GOCMD = go
GOBUILD = $(GOCMD) build
GOCLEAN = $(GOCMD) clean
GOTEST = $(GOCMD) test
GOGET = $(GOCMD) get

BINARY_NAME = notification-email$(EXT)

build: clean
	$(GOBUILD) $(LD_OPTS) $(BUILD_VENDOR_FLAGS) -o $(BINARY_NAME)

clean:
	@$(RM) $(BINARY_NAME) $(WIN_IGNORE_ERR)

=== plugins/notifications/http/Makefile ===
ifeq ($(OS), Windows_NT)
	SHELL := pwsh.exe
	.SHELLFLAGS := -NoProfile -Command
	EXT = .exe
endif

# Go parameters
GOCMD = go
GOBUILD = $(GOCMD) build
GOCLEAN = $(GOCMD) clean
GOTEST = $(GOCMD) test
GOGET = $(GOCMD) get

BINARY_NAME = notification-http$(EXT)

build: clean
	$(GOBUILD) $(LD_OPTS) $(BUILD_VENDOR_FLAGS) -o $(BINARY_NAME)

clean:
	@$(RM) $(BINARY_NAME) $(WIN_IGNORE_ERR)

=== plugins/notifications/slack/Makefile ===
ifeq ($(OS), Windows_NT)
	SHELL := pwsh.exe
	.SHELLFLAGS := -NoProfile -Command
	EXT = .exe
endif

# Go parameters
GOCMD = go
GOBUILD = $(GOCMD) build
GOCLEAN = $(GOCMD) clean
GOTEST = $(GOCMD) test
GOGET = $(GOCMD) get

BINARY_NAME = notification-slack$(EXT)

build: clean
	$(GOBUILD) $(LD_OPTS) $(BUILD_VENDOR_FLAGS) -o $(BINARY_NAME)

clean:
	@$(RM) $(BINARY_NAME) $(WIN_IGNORE_ERR)

=== plugins/notifications/splunk/Makefile ===
ifeq ($(OS), Windows_NT)
	SHELL := pwsh.exe
	.SHELLFLAGS := -NoProfile -Command
	EXT = .exe
endif

# Go parameters
GOCMD = go
GOBUILD = $(GOCMD) build
GOCLEAN = $(GOCMD) clean
GOTEST = $(GOCMD) test
GOGET = $(GOCMD) get

BINARY_NAME = notification-splunk$(EXT)

build: clean
	$(GOBUILD) $(LD_OPTS) $(BUILD_VENDOR_FLAGS) -o $(BINARY_NAME)

clean:
	@$(RM) $(BINARY_NAME) $(WIN_IGNORE_ERR)

=== debian/changelog ===
crowdsec (1.4.6-6ubuntu0.24.04.2) noble-security; urgency=medium

  * No change rebuild due to golang-1.22 update 

 -- Evan Caville <evan.caville@canonical.com>  Fri, 20 Jun 2025 14:45:28 +1000

crowdsec (1.4.6-6ubuntu0.24.04.1) noble-security; urgency=medium

  * No change rebuild due to golang-1.21 update

 -- Nishit Majithia <nishit.majithia@canonical.com>  Wed, 10 Jul 2024 12:19:01 +0530

crowdsec (1.4.6-6build1) mantic; urgency=medium

  * No-change rebuild with Go 1.21.

 -- Michael Hudson-Doyle <michael.hudson@ubuntu.com>  Thu, 24 Aug 2023 17:13:32 +1200

crowdsec (1.4.6-6) unstable; urgency=medium

  * Disable unreliable TestStreaming test, as seen under autopkgtest
    (https://github.com/crowdsecurity/crowdsec/issues/2352):
     - 0019-disable-unreliable-test-TestStreaming.patch

 -- Cyril Brulebois <cyril@debamax.com>  Fri, 14 Jul 2023 20:54:27 +0200

crowdsec (1.4.6-5) unstable; urgency=medium

  * Fix default acquis.yaml to also include the journalctl datasource,
    limited to the ssh.service unit, making sure acquisition works even
    without the traditional auth.log file (Closes: #1040976):
     - 0017-fix-default-acquisition.patch
  * Make sure an invalid datasource doesn't make the engine error out,
    making it possible to include the journalctl datasource in the default
    config file unconditionally, without having to worry whether
    journalctl is actually deployed and usable:
     - 0018-non-fatal-errors-for-invalid-datasources.patch

 -- Cyril Brulebois <cyril@debamax.com>  Thu, 13 Jul 2023 17:23:01 +0200

crowdsec (1.4.6-4) unstable; urgency=medium

  * Implement support for pending registration: since bouncers list crowdsec
    in Recommends, we cannot guarantee the order in which bouncers and
    crowdsec are configured (See: #1035499, #1036985). Bouncers can now
    queue triplets (systemd unit name, bouncer identifier and API key) in
    /var/lib/crowdsec/pending-registration. crowdsec.postinst will register
    those bouncers, and start their systemd units after removing that file
    (satisfying their ConditionPathExists=! on it).
  * Replace `exit 0` with `break` in the preceding code block.

 -- Cyril Brulebois <cyril@debamax.com>  Wed, 31 May 2023 18:54:17 +0200

crowdsec (1.4.6-3) unstable; urgency=medium

  * When performing an upgrade from pre-1.4.x versions, apply a workaround
    to avoid losing CAPI decisions for several hours (Closes: #1033138):
    delete alert(s) matching “Community blocklist”, and if at least one
    deletion occurred, restart the daemon to force an immediate pull.
  * Hardcode libsqlite3-0 (>= 3.35.0) in Depends to ensure Ent-generated
    SQLite queries are understood (Closes: #1033132): otherwise, we would
    get a dependency on libsqlite3-0 (>= 3.12.0) via shlibs, which is
    clearly not enough.
  * Backport upstream patch to fix building in the past/in the future (as
    seen with reproducible builds), no longer hardcoding the expected year
    for yearless timestamps:
     - 0016-try-to-make-reproducible-build-work-2119.patch

 -- Cyril Brulebois <cyril@debamax.com>  Sun, 19 Mar 2023 00:25:07 +0100

crowdsec (1.4.6-2) unstable; urgency=medium

  * Prefix package version with `v` when setting BUILD_VERSION, e.g.
    crowdsec/v1.4.6-2-linux-debian (Closes: #1031324).
  * Stop shipping a logrotate configuration snippet, as crowdsec rotates
    logs on its own via lumberjack.Logger, and that can be configured in
    the main configuration file (/etc/crowdsec/config.yaml):
     - Delete debian/crowdsec.logrotate
     - Add debian/crowdsec.conffiles, marking /etc/logrotate.d/crowdsec
       with the remove-on-upgrade flag.
  * When purging the package, remove internally-rotated log files, in
    addition to removing main log files and the logrotate-generated ones.
  * Really enable upstream-recommended collections, not just the items
    they require: everything would work fine without this, but those
    collections wouldn't appear in `cscli collections list`, and they
    wouldn't be upgraded if admins decided to switch to the online hub.
  * Compensate for the missing collections when upgrading from 1.4.6-1
    specifically (including binNMUs).
  * Enable the crowdsecurity/whitelists parser as well.
  * When performing a fresh install (as determined by the postinst's being
    called with just `configure`), and when /run/systemd/system exists,
    apply a workaround for upstream issue #2120 based on crowdsec.log:
     - Exit immediately if the unit is not active (e.g. the admin masked
       it before installing the package).
     - Check whether entries are received from the Central API, and exit
       if that's the case.
     - Check whether `received 0 new entries` is logged, and restart then
       exit if that's the case.
     - Repeat those checks every second, up to 20 times.
  * When performing an upgrade from pre-1.4.x versions, apply a workaround
    to avoid huge delays at the `restart` step: lower TimeoutStopSec from
    90s (default) to only 20s, using a runtime override (Closes: #1031326).
  * Add a dh_install-indep override to get rid of files left over after
    running the test suite (Closes: #1031328).

 -- Cyril Brulebois <cyril@debamax.com>  Fri, 17 Mar 2023 14:42:04 +0100

crowdsec (1.4.6-1) unstable; urgency=medium

  * New upstream release (Closes: #1031322).
  * Include a snapshot of hub files from the v1.4.6 branch, at commit
    f23a543a80.
  * Delete patch:
     - 0012-work-around-buggy-testparse-test.patch (fixed upstream)
  * Extend patch to avoid crowdsecurity/linux's being marked tainted:
     - 0004-disable-geoip-enrich.patch
  * Extend patch to skip more unreliable tests:
     - 0013-skip-flakky-tests.patch
  * Add patches:
     - 0014-silence-yaml-patching.patch: avoid polluting cscli's output
       with debug messages.
     - 0015-silence-not-latest-version.patch: upstream maintains a hub
       branch for our stable release (Closes: #1031323).
  * Rework collections handling:


=== debian/control ===
Source: crowdsec
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Cyril Brulebois <cyril@debamax.com>
Uploaders: Debian Go Packaging Team <team+pkg-go@tracker.debian.org>
Section: golang
Testsuite: autopkgtest-pkg-go
Priority: optional
Build-Depends: debhelper-compat (= 13),
               dh-golang,
               golang-any,
               golang-entgo-ent-dev,
               golang-github-alecaivazis-survey-dev,
               golang-github-alexliesenfeld-health-dev,
               golang-github-antonmedv-expr-dev,
               golang-github-appleboy-gin-jwt-dev,
               golang-github-aquasecurity-table-dev,
               golang-github-beevik-etree-dev,
               golang-github-blackfireio-osinfo-dev,
               golang-github-buger-jsonparser-dev,
               golang-github-c-robinson-iplib-dev,
               golang-github-confluentinc-bincover-dev,
               golang-github-coreos-go-systemd-dev,
               golang-github-crowdsecurity-dlog-dev,
               golang-github-crowdsecurity-grokky-dev,
               golang-github-crowdsecurity-machineid-dev,
               golang-github-davecgh-go-spew-dev,
               golang-github-dghubble-sling-dev,
               golang-github-docker-docker-dev,
               golang-github-docker-go-connections-dev,
               golang-github-enescakir-emoji-dev,
               golang-github-gin-gonic-gin-dev (>= 1.8.1),
               golang-github-go-co-op-gocron-dev,
               golang-github-go-openapi-errors-dev,
               golang-github-go-openapi-strfmt-dev,
               golang-github-go-openapi-swag-dev,
               golang-github-go-openapi-validate-dev,
               golang-github-go-sql-driver-mysql-dev,
               golang-github-google-go-querystring-dev,
               golang-github-goombaio-namegenerator-dev,
               golang-github-hashicorp-go-plugin-dev,
               golang-github-hashicorp-go-version-dev,
               golang-github-ivanpirog-coloredcobra-dev,
               golang-github-jackc-pgx-v4-dev,
               golang-github-jarcoal-httpmock-dev,
               golang-github-jszwec-csvutil-dev,
               golang-github-lib-pq-dev,
               golang-github-masterminds-sprig-dev,
               golang-github-mattn-go-sqlite3-dev,
               golang-github-mohae-deepcopy-dev,
               golang-github-nxadm-tail-dev,
               golang-github-opencontainers-image-spec-dev,
               golang-github-oschwald-geoip2-golang-dev (>= 1.2),
               golang-github-oschwald-maxminddb-golang-dev (>= 1.4),
               golang-github-pbnjay-memory-dev,
               golang-github-pkg-errors-dev,
               golang-github-prometheus-client-golang-dev,
               golang-github-prometheus-client-model-dev,
               golang-github-prometheus-prom2json-dev,
               golang-github-r3labs-diff-dev,
               golang-github-sirupsen-logrus-dev,
               golang-github-slack-go-slack-dev,
               golang-github-spf13-cobra-dev,
               golang-github-stretchr-testify-dev,
               golang-github-texttheater-golang-levenshtein-dev,
               golang-github-xhit-go-simple-mail-dev,
               golang-golang-x-crypto-dev,
               golang-golang-x-mod-dev,
               golang-golang-x-sys-dev,
               golang-gopkg-natefinch-lumberjack.v2-dev,
               golang-gopkg-tomb.v2-dev,
               golang-gopkg-yaml.v2-dev,
               python3,
               systemd
Standards-Version: 4.5.0
Vcs-Browser: https://salsa.debian.org/go-team/packages/crowdsec
Vcs-Git: https://salsa.debian.org/go-team/packages/crowdsec.git
Homepage: https://github.com/crowdsecurity/crowdsec
Rules-Requires-Root: no
XS-Go-Import-Path: github.com/crowdsecurity/crowdsec

Package: crowdsec
Architecture: any
Depends: ca-certificates,
         ${misc:Depends},
         ${shlibs:Depends},
         libsqlite3-0 (>= 3.35.0),
Built-Using: ${misc:Built-Using}
Description: lightweight and collaborative security engine
 CrowdSec is a lightweight security engine, able to detect and remedy
 aggressive network behavior. It can leverage and also enrich a
 global community-wide IP reputation database, to help fight online
 cybersec aggressions in a collaborative manner.
 .
 CrowdSec can read many log sources, parse and also enrich them, in
 order to detect specific scenarios, that usually represent malevolent
 behavior. Parsers, Enrichers, and Scenarios are YAML files that can
 be shared and downloaded through a specific Hub, as well as be created
 or adapted locally.
 .
 Detection results are available for CrowdSec, its CLI tools and
 bouncers via an HTTP API. Triggered scenarios lead to an alert, which
 often results in a decision (e.g. IP banned for 4 hours) that can be
 consumed by bouncers (software components enforcing a decision, such
 as an iptables ban, an nginx lua script, or any custom user script).
 .
 The CLI allows users to deploy a Metabase Docker image to provide
 simple-to-deploy dashboards of ongoing activity. The CrowdSec daemon
 is also instrumented with Prometheus to provide observability.
 .
 CrowdSec can be used against live logs (“à la fail2ban”), but can
 also work on cold logs to help, in a forensic context, to build an
 analysis for past events.
 .
 On top of that, CrowdSec aims at sharing detection signals amongst
 all participants, to pre-emptively allow users to block likely
 attackers. To achieve this, minimal meta-information about the attack
 is shared with the CrowdSec organization for further retribution.
 .
 Users can also decide not to take part into the collective effort via
 the central API, but to register on a local API instead.

Package: golang-github-crowdsecurity-crowdsec-dev
Architecture: all
Multi-Arch: foreign
Depends: golang-entgo-ent-dev,
         golang-github-alecaivazis-survey-dev,
         golang-github-alexliesenfeld-health-dev,
         golang-github-antonmedv-expr-dev,
         golang-github-appleboy-gin-jwt-dev,
         golang-github-aquasecurity-table-dev,
         golang-github-beevik-etree-dev,
         golang-github-blackfireio-osinfo-dev,
         golang-github-buger-jsonparser-dev,
         golang-github-c-robinson-iplib-dev,
         golang-github-confluentinc-bincover-dev,
         golang-github-coreos-go-systemd-dev,
         golang-github-crowdsecurity-dlog-dev,
         golang-github-crowdsecurity-grokky-dev,
         golang-github-crowdsecurity-machineid-dev,
         golang-github-davecgh-go-spew-dev,
         golang-github-dghubble-sling-dev,
         golang-github-docker-docker-dev,
         golang-github-docker-go-connections-dev,
         golang-github-enescakir-emoji-dev,
         golang-github-gin-gonic-gin-dev (>= 1.8.1),
         golang-github-go-co-op-gocron-dev,
         golang-github-go-openapi-errors-dev,
         golang-github-go-openapi-strfmt-dev,
         golang-github-go-openapi-swag-dev,
         golang-github-go-openapi-validate-dev,
         golang-github-go-sql-driver-mysql-dev,
         golang-github-google-go-querystring-dev,
         golang-github-goombaio-namegenerator-dev,
         golang-github-hashicorp-go-plugin-dev,
         golang-github-hashicorp-go-version-dev,
         golang-github-ivanpirog-coloredcobra-dev,
         golang-github-jackc-pgx-v4-dev,
         golang-github-jarcoal-httpmock-dev,
         golang-github-jszwec-csvutil-dev,
         golang-github-lib-pq-dev,
         golang-github-masterminds-sprig-dev,
         golang-github-mattn-go-sqlite3-dev,
         golang-github-mohae-deepcopy-dev,
         golang-github-nxadm-tail-dev,
         golang-github-opencontainers-image-spec-dev,
         golang-github-oschwald-geoip2-golang-dev (>= 1.2),
         golang-github-oschwald-maxminddb-golang-dev (>= 1.4),
         golang-github-pbnjay-memory-dev,
         golang-github-pkg-errors-dev,
         golang-github-prometheus-client-golang-dev,
         golang-github-prometheus-client-model-dev,
         golang-github-prometheus-prom2json-dev,
         golang-github-r3labs-diff-dev,
         golang-github-sirupsen-logrus-dev,
         golang-github-slack-go-slack-dev,
         golang-github-spf13-cobra-dev,
         golang-github-stretchr-testify-dev,
         golang-github-texttheater-golang-levenshtein-dev,
         golang-github-xhit-go-simple-mail-dev,
         golang-golang-x-crypto-dev,
         golang-golang-x-mod-dev,
         golang-golang-x-sys-dev,
         golang-gopkg-natefinch-lumberjack.v2-dev,
         golang-gopkg-tomb.v2-dev,
         golang-gopkg-yaml.v2-dev,
         python3,
         ${misc:Depends}
Description: lightweight and collaborative security engine - library
 CrowdSec is a lightweight security engine, able to detect and remedy
 aggressive network behavior. It can leverage and also enrich a
 global community-wide IP reputation database, to help fight online
 cybersec aggressions in a collaborative manner.
 .
 This package contains the development files.

=== debian/watch ===
version=4
opts="filenamemangle=s%(?:.*?)?v?(\d[\d.]*)\.tar\.gz%crowdsec-$1.tar.gz%,\
      uversionmangle=s/(\d)[_\.\-\+]?(RC|rc|pre|dev|beta|alpha)[.]?(\d*)$/\$1~\$2\$3/" \
  https://github.com/crowdsecurity/crowdsec/tags .*/v?(\d\S*)\.tar\.gz debian
